//
// Simple passthrough vertex shader
//
attribute vec3 in_Position;                  // (x,y,z)
//attribute vec3 in_Normal;                  // (x,y,z)     unused in this shader.
attribute vec4 in_Colour;                    // (r,g,b,a)
attribute vec2 in_TextureCoord;              // (u,v)

varying vec2 v_vTexcoord;
varying vec4 v_vColour;

void main()
{
    vec4 object_space_pos = vec4( in_Position.x, in_Position.y, in_Position.z, 1.0);
    gl_Position = gm_Matrices[MATRIX_WORLD_VIEW_PROJECTION] * object_space_pos;
    
    v_vColour = in_Colour;
    v_vTexcoord = in_TextureCoord;
}

//######################_==_YOYO_SHADER_MARKER_==_######################@~//
// Simple passthrough fragment shader
//
varying vec2 v_vTexcoord;
varying vec4 v_vColour;

uniform float u_intensity;

void main()
{

  vec2 victor = v_vTexcoord - vec2(0.5,0.5);
  float u_BlurLevel = length(victor)*0.002;

  vec4 sum = vec4(0.0);
 
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x - u_BlurLevel, v_vTexcoord.y)) * 0.09;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x + u_BlurLevel, v_vTexcoord.y)) * 0.09;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x, v_vTexcoord.y - u_BlurLevel)) * 0.09;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x, v_vTexcoord.y + u_BlurLevel)) * 0.09;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x - u_BlurLevel, v_vTexcoord.y - u_BlurLevel)) * 0.08;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x + u_BlurLevel, v_vTexcoord.y - u_BlurLevel)) * 0.08;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x - u_BlurLevel, v_vTexcoord.y + u_BlurLevel)) * 0.08;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x + u_BlurLevel, v_vTexcoord.y + u_BlurLevel)) * 0.08;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x - 2.*u_BlurLevel, v_vTexcoord.y)) * 0.04;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x + 2.*u_BlurLevel, v_vTexcoord.y)) * 0.04;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x, v_vTexcoord.y - 2.*u_BlurLevel)) * 0.04;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x, v_vTexcoord.y + 2.*u_BlurLevel)) * 0.04;
  sum += texture2D(gm_BaseTexture, vec2(v_vTexcoord.x, v_vTexcoord.y)) * 0.16;

  gl_FragColor = v_vColour * sum;

}

